//------------------------------------------------------------------------------
// <autogenerated>
//     This code was generated by a tool.
//     Runtime Version: 1.1.4322.2032
//
//     Changes to this file may cause incorrect behavior and will be lost if 
//     the code is regenerated.
// </autogenerated>
//------------------------------------------------------------------------------

namespace SharpReportCore {
	using System;
	using System.ComponentModel;
	using System.Xml.Serialization;
	
	using System.Drawing;	
	
	/// <summary>
	/// This Class is the BaseClass for <see cref="BaseTextItem"></see>
	/// and <see cref="BaseGraphicItem"></see>
	/// </summary>
	
	public class BaseReportItem : SharpReportCore.BaseReportObject,
											IItemRenderer{
		
		private int xOffset;
		private bool drawBorder;	
		private Color foreColor;
		
		private Font font;
		
		public event EventHandler<BeforePrintEventArgs> BeforePrinting;
		public event EventHandler<AfterPrintEventArgs> AfterPrinting;
		
		public event EventHandler <FormatOutputEventArgs> FormatOutput;
		public event EventHandler Disposed;
		
		public BaseReportItem() :base(){
			
		}
		
		#region Event's handling
		/// <summary>
		/// Format a string according to his datatype
		/// </summary>
		/// <param name="toFormat">The String to Format</param>
		/// <param name="formatString">the formatString</param>
		/// <param name="nullValue">Value to return when there is null in toFormat</param>
		/// <returns></returns>
		protected string FireFormatOutput(string toFormat,string format, string nullValue) {
			if (FormatOutput != null) {
				FormatOutputEventArgs ea = new FormatOutputEventArgs (toFormat,
				                                                      format,
				                                                      nullValue);
				FormatOutput (this,ea);
				return ea.FormatedValue;
			}
			return toFormat;
		}
		
		#endregion
		
		#region EventHandling
		public void NotiyfyAfterPrint (PointF afterPrintLocation) {
			if (this.AfterPrinting != null) {
				AfterPrintEventArgs rea = new AfterPrintEventArgs (afterPrintLocation);
				AfterPrinting(this, rea);
			}
		}
		
		public void NotifyBeforePrint () {
			if (this.BeforePrinting != null) {
				BeforePrintEventArgs ea = new BeforePrintEventArgs ();
				BeforePrinting (this,ea);
			}
		}
		
		#endregion
		#region virtual method's
		protected RectangleF DrawingRectangle (ReportPageEventArgs e,SizeF measureSize) {
			
			PointF upperLeft = new PointF (this.Location.X ,
			                             this.Location.Y + this.SectionOffset);
			SizeF lowerRight = new SizeF(0,0);
			
			if ((this.CanGrow == true )||(this.CanShrink == true)){
				if (measureSize.Height > this.Size.Height ) {
					lowerRight = new SizeF (this.Size.Width,
					                         measureSize.Height);
				                   
				}
			} else {
				lowerRight = new SizeF (this.Size.Width,
					                    this.Size.Height);
			}
			return new RectangleF (upperLeft,lowerRight);		                       
		}
		
		#endregion
		
		#region Properties
		
		[XmlIgnoreAttribute]
		[Browsable(false)]
		public int XOffset {
			get {
				return xOffset;
			}
			set {
				xOffset = value;
			}
		}
		
		
		[Browsable(true),
		 Category("Appearance"),
		 Description("Draw a Border around the Item")]
		public bool DrawBorder {
			get {
				return drawBorder;
			}
			set {
				drawBorder = value;
			}
		}
		
		public virtual Color ForeColor {
			get {
				return foreColor;
			}
			set {
				foreColor = value;
				base.NotifyPropertyChanged ("ForeColor");
			}
		}
		
		
		public virtual Font Font {
			get {
				return this.font;
			}
			set {
				this.font = value;
				NotifyPropertyChanged ("Font");
			}
		}
		
		#endregion
		
		#region IDisposeable
		public override void Dispose () {
			Dispose(true);
            GC.SuppressFinalize(this);
		}
		
		~BaseReportItem(){
			Dispose(false);
		}
		
		protected override void Dispose(bool disposing) {
			try {
				if (disposing){
					if (this.font != null){
						this.font = null;
						this.font.Dispose();
					}
				}
			} finally {
				if (this.Disposed != null) {
					this.Disposed (this,EventArgs.Empty);
				}
				base.Dispose(disposing);
			}
		}

		#endregion
		
	}
}
